/*============================================================================
|   Copyright (C) 2001-2002  Jonathan Harm
|
|
|   This program is free software; you can redistribute it and/or
|   modify it under the terms of the GNU General Public License
|   as published by the Free Software Foundation; either version 2
|   of the License, or (at your option) any later version.
|   This program is distributed in the hope that it will be useful,
|   but WITHOUT ANY WARRANTY; without even the implied warranty of
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
|   GNU General Public License for more details.
|   You should have received a copy of the GNU General Public License
|   along with this program; if not, write to the Free Software
|
|   Foundation, Inc.,
|   59 Temple Place - Suite 330
|   Boston, MA  02111-1307, USA.
|
|
|
|                   main.c  REV 6  for SQL Query Generator
|
|  This program is under the GPL see http://www.gnu.org for more info
|
|
|                   http://change.to/opensource
|                   110983@lycos.com
|
\============================================================================*/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include "querygen.h"


void show_usage(char *progname );

int main(int argc, char *argv[])
{



    extern char out[MAX];
    extern char ctqfile[MAX];
    char option, call_function;
    int i, optioncount = 0;
    extern int appendfile; //the option for appending a file
    //extern int multiplequeryies; //option for multiple CREATE TABLE queries





   if( (argc > 5) || (argc < 4) )
   {
     show_usage( argv[0]);
   }



    //get input and output filenames
   sprintf(out, "%s", argv[--argc]);
   sprintf(ctqfile, "%s", argv[--argc]);


for(i = 1; i < argc; i++)
{



   //now check to see if the option starts with the '-'
   if(argv[i][0] == '-')
       while( isalpha(argv[i][++optioncount]) != 0)
       {
            //argv[1][1] contains the letter after the '-'
            option = argv[i][optioncount];

             //the option switch
             switch(option)
             {

                 case 'i':
                   call_function = argv[i][optioncount];
                   break;

                 case 'u':
                   call_function = argv[i][optioncount];
                   break;

                  case 'd':
                    call_function = argv[i][optioncount];
                    break;

                  case 'a':
                    appendfile = 1;  //option for appending the output file
                    break;

                   default:
                     show_usage( argv[0] );
                     break;

             }

         } //end while(isspace(argv[i][++optioncount]) != 0)



         else  { fprintf(stderr, "error with one of the options\n");   }




   } //end of for loop


             //switch to call the functions
             switch(call_function)
             {

                 case 'i':
                   insert_query();
                   break;

                 case 'u':
                    update_query();
                    break;

                 case 'd':
                    delete_query();
                    break;

                  default:
                     show_usage( argv[0] );
                     break;

               }



  return 0;
}


//when calling this function, just pass argv[0] because that is the program name
void show_usage(char *progname)
{

          printf("\n\nSQL Query Generator %.1f\t by Jonathan Harm\n", PROGRAM_VERSION);
          printf("\nusage: %s [OPTION] [INPUT] [OUTPUT FILE]", progname);
          printf("\n\n\tOption\tDescription\n");
          printf("\n\t-i\tmake an INSERT INTO query");
          printf("\n\t-u\tmake an UPDATE query");
          printf("\n\t-d\tmake a DELETE query");
          printf("\n\t-a\tappend the output file\n\n");
          exit(1);
}

