/*============================================================================
|   Copyright (C) 2001-2002  Jonathan Harm
| 
| 
|   This program is free software; you can redistribute it and/or 
|   modify it under the terms of the GNU General Public License 
|   as published by the Free Software Foundation; either version 2 
|   of the License, or (at your option) any later version. 
|   This program is distributed in the hope that it will be useful, 
|   but WITHOUT ANY WARRANTY; without even the implied warranty of 
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
|   GNU General Public License for more details. 
|   You should have received a copy of the GNU General Public License 
|   along with this program; if not, write to the Free Software 
|    
|   Foundation, Inc.,  
|   59 Temple Place - Suite 330 
|   Boston, MA  02111-1307, USA. 
| 
|   
| 
|                   update_query.c REV 6 or SQL Query Generator
| 
|  This program is under the GPL see http://www.gnu.org for more info 
| 
|   
|                   http://change.to/opensource 
|                   110983@lycos.com 
| 
\============================================================================*/ 


#include "querygen.h"


void update_query( void )
{



  extern char out[MAX];
  extern char ctqfile[MAX];		                    // this is the CREATE TABLE query file
  char update_query[BIGBUF];                 //this is what is written to the file
  char unique_query[BIGBUF];                 //part of the query that contains "WHERE x = y"
  char unique_info[MAX];                         //information unique to the row(s) being updated
  char input_string[BIGBUF];                   //for the user to input the data to update the column
  char update_column[MAX];                   //the column to be updated
  char unique_column[MAX];                   //column containing unique info for updating only certian row(s)
  char *tablename, *p_ctqbuf;
  int user_done;                                      //ask user if they are done(this will be either Y or N)
  int loop_done;                                      //used to control when the while loop ends
  extern int appendfile;                            //option for appending output file
  char col_or_row;                                   //when asking user "[C]olumn or [R]ow"
  sqltable *column;                                  //used for finding the datatype of a column

 // used for converting a string to a numerical
 //datatype when creating the unique_query string
  char        input_tinyint;
  int           input_smallint;
  long        input_integer;
  float        input_floatingpoint;




  FILE *fpctq, *fpout;




  //First open "ctq" in read only mode and open "out" for writing

  if( (fpctq = fopen(ctqfile, "r")) == NULL) {
    fprintf(stderr, "\nCouldn't open file %s\n", ctqfile);
    exit(1);
    }


if(appendfile == 1)
{

    if( (fpout = fopen(out, "a")) == NULL)
    {
       fprintf(stderr, "\nCouldn't create file %s\n", out);
       exit(2);
      }

}


else
{

      if( (fpout = fopen(out, "w")) == NULL)
      {
          fprintf(stderr, "\nCouldn't create file %s\n", out);
          exit(2);
       }


}

  fprintf(fpout, "\n/* This file made by SQL Query Generator %.1f*/\n", PROGRAM_VERSION);
  fprintf(fpout, "/* go to http://change.to/opensource for the latest updates */\n\n\n");





//in this loop, ask what column to update
//and weather to update the whole column
  while( loop_done != 1 )
  {

      input_string[0] = '\0'; //set to null for error checking


       if( (tablename = gettable(fpctq)) == 0)
      exit(1);



      printf("What column do you want to update?");
      fgets(update_column, MAX, stdin);  update_column[strlen(update_column)-1] = '\0';
      //remove newline char and replace it with NULL

     //Advance to the right spot in fpctq
                         rewind(fpctq);
                   //first get to the part of the fpctq file that creates
                   //the columns for the table that the user wants
                  //to make a query for

                 while ( (p_ctqbuf = skipcomment(fpctq)) != NULL )
                 {
                      if(strcmp(p_ctqbuf, tablename) == 0)
                      break;

                     //TODO: should do error checking here, check for EOF.
                  }
     

      //need to getcolumn for the column->null error checking
      while( (column = getcolumn(fpctq)) != 0)
       {
               if( strcmp(update_column, column->name) == 0)
               break;
       }



      /*ask user if they want to update the entire
        column or just 1 row */

      printf("Would you like to update the entire [C]olumn or only specific [R]ow(s)?\n");
        col_or_row = toupper(  fgetc(stdin) );
        getc(stdin); //eat newline character so fgets doesn't get it


      if( col_or_row == 'C')
      {


            //prompt user to input data, then write it to the output file
            printf("Now type in the information to update %s\n", update_column);

            //do column->null error checking
            if(column->null == 1)
            {
                   while(input_string[0] == '\0')
                   {
                        fgets(input_string, MAX, stdin);   input_string[strlen(input_string)-1] ='\0';
                   }
            }

             else { fgets(input_string, MAX, stdin);   input_string[strlen(input_string)-1] ='\0'; }



                       //for now, just check to see if it is or isn't numerical
                        if( strcmp(column->type, "CHAR") == 0)
                         sprintf(update_query, "UPDATE %s\nSET %s = \'%s\'", tablename, update_column, input_string);


                        else
                         sprintf(update_query, "UPDATE %s\nSET %s = %s", tablename, update_column, input_string);


            fprintf(fpout, "%s;", update_query);

       }


        else if(col_or_row == 'R')
        {

               //so the user only wants to update certain row(s).
               //TODO:  display list of columns for user (version 0.3 or later)
               //1. ask user what column  contains information unique to the row(s) they want to update
               //2. ask user what that information is


            //prompt user to input data, then write it to the update_query string
            printf("Now type in the information to update %s\n", update_column);

            //do column->null error checking
            if(column->null == 1)
            {
                   while(input_string[0] == '\0')
                   {
                        fgets(input_string, MAX, stdin);   input_string[strlen(input_string)-1] ='\0';
                   }
            }

             else { fgets(input_string, MAX, stdin);   input_string[strlen(input_string)-1] ='\0'; }

            sprintf(update_query, "UPDATE %s\nSET %s = ", tablename, update_column);


            //1. ask user what column contains the unique info
            // Also use getcolumn() to get the datatype
            printf("\nWhat column contains the information unique to the row(s) you want to update?");
            fgets(unique_column, MAX, stdin);  unique_column[strlen(unique_column)-1] = '\0';


            //2. ask user to type in the information unique to that row(s)
            printf("\nNow type in the information that is unique in that column.\n");
            fgets(unique_info, MAX, stdin);   unique_info[strlen(unique_info)-1] = '\0';



                   rewind(fpctq);
                   //first get to the part of the fpctq file that creates
                   //the columns for the table that the user wants
                  //to make a query for

                 while ( (p_ctqbuf = skipcomment(fpctq)) != NULL )
                 {
                      if(strcmp(p_ctqbuf, tablename) == 0)
                      break;

                     //TODO: should do error checking here, check for EOF.
                  }


             //  |  get datatype of column so the program will
            //  \/ know if it needs to put qoutes around the input
     
            while( (column = getcolumn(fpctq)) != 0)
            {

                 //as soon as the column name is found check to see if it is numerical or string
                 //datatype so the program can put quotes around numerical data and leave
                 //qoutes off of strings
                 if( strcmp(column->name, unique_column) == 0)
                 {

                   //first take care of numerical datatypes

                     if( strcmp(column->type,"SMALLINT") == 0)
                      {
                        input_smallint = atoi(unique_info);
                        sprintf(unique_query, "WHERE %s = %d", unique_column, input_smallint);
                      }


                     else if( strcmp(column->type,"TINYINT") == 0)
                      {
                        input_tinyint = atoi(unique_info);
                        sprintf(unique_query,"WHERE %s = %d", unique_column, input_tinyint);
                      }


                     else if( strcmp(column->type,"FLOAT") == 0)
                      {
                        input_floatingpoint = atoi(unique_info);
                        sprintf(unique_query,"WHERE %s = %f", unique_column, input_floatingpoint);
                      }


                     else if( strcmp(column->type,"INTEGER") == 0 || strcmp(column->type,"REAL") == 0)
                      {
                        input_integer = atoi(unique_info);
                        sprintf(unique_query,"WHERE %s = %ld", unique_column, input_integer);


                     }


          /*
         //               Done with the numerical data.  Everything below this line
         //               will only deal with character type data.
         //=====================================================*/


                      else if( strcmp(column->type,"CHAR") == 0)
                       {
                         sprintf(unique_query,"WHERE %s = \'%s\'", unique_column, unique_info);


                       }


                    // if the datatype of the column the user entered data for
                    // was not in the above if statement, then that datatype is
                    // not supported
                    else
                     {
                       fprintf(stderr, "Datatype %s not supported\n", column->type);
                     }


                 }



         /*==================================================================*/
                 /*= deal with qoutes that may or may not need to be around input_string==*/

                   if( strcmp(column->name, update_column) == 0)
                   {


                     if( strcmp(column->type,"SMALLINT") == 0)
                      {
                        strcat(update_query, input_string);
                      }


                     else if( strcmp(column->type,"TINYINT") == 0)
                      {
                        strcat(update_query, input_string);
                      }


                     else if( strcmp(column->type,"FLOAT") == 0)
                      {
                         strcat(update_query, input_string);
                      }


                     else if( strcmp(column->type,"INTEGER") == 0 || strcmp(column->type,"REAL") == 0)
                      {
                         strcat(update_query, input_string);
                      }


          /*
         //               Done with the numerical data.  Everything below this line
         //               will only deal with character type data.
         //=====================================================*/


                      else if( strcmp(column->type,"CHAR") == 0)
                       {
                         strcat(update_query, "\'");
                         strcat(update_query, input_string);
                         strcat(update_query, "\'");
                       }


                    // if the datatype of the column the user entered data for
                    // was not in the above if statement, then that datatype is
                    // not supported
                    else
                     {
                       fprintf(stderr, "Datatype %s not supported\n", column->type);
                     }

                }


            } //end of while loop



            //and finally write it to the file
            fprintf(fpout, "%s\n%s;\n\n", update_query, unique_query);

         } //end of "else if(col_or_row == 'R')"



         else
         {
            fprintf(stderr, "You did not enter C or R\n");
            exit(1);
         }







     printf("\n\nAre you done entering data?(N/y)");

       user_done = toupper(getc(stdin));


       switch (user_done) {

                 case 'Y' :

                     printf("\nThank you for using SQL Query Generator %.1f.\n", PROGRAM_VERSION);

                      //close files before exiting
                      fclose(fpout);
                      fclose(fpctq);
                      loop_done = 1;

                      break;


                 case 'N' :
                       loop_done = 0;
                       memset(update_query, ' ', BIGBUF);
                       memset(unique_query, ' ', BIGBUF);

                       getc(stdin); //eat newline

                       break;


                 default :
                        loop_done = 0;
                        memset(update_query, ' ', BIGBUF);
                        memset(unique_query, ' ', BIGBUF);

                         break;

                } //end of switch



  } //end while loop



exit(0);

}

